/*
*************************************************************************
**  Copyright (c) 2019 CentraleSupélec & EDF.
**  All rights reserved. This program and the accompanying materials
**  are made available under the terms of the Eclipse Public License v2.0
**  which accompanies this distribution, and is available at
**  https://www.eclipse.org/legal/epl-v20.html
** 
**  This file is part of the RiseClipse tool
**  
**  Contributors:
**      Computer Science Department, CentraleSupélec
**      EDF R&D
**  Contacts:
**      dominique.marcadet@centralesupelec.fr
**      aurelie.dehouck-neveu@edf.fr
**  Web site:
**      http://wdi.supelec.fr/software/RiseClipse/
*************************************************************************
*/
package fr.centralesupelec.edf.riseclipse.iec61850.scl;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Services</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getNameLength <em>Name Length</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getParentAccessPoint <em>Parent Access Point</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getClientServices <em>Client Services</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getCommProt <em>Comm Prot</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfDataSet <em>Conf Data Set</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLNs <em>Conf LNs</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLdName <em>Conf Ld Name</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLogControl <em>Conf Log Control</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfReportControl <em>Conf Report Control</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfSigRef <em>Conf Sig Ref</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDataObjectDirectory <em>Data Object Directory</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDataSetDirectory <em>Data Set Directory</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDynAssociation <em>Dyn Association</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDynDataSet <em>Dyn Data Set</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getFileHandling <em>File Handling</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGOOSE <em>GOOSE</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSEDir <em>GSE Dir</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSESettings <em>GSE Settings</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSSE <em>GSSE</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetCBValues <em>Get CB Values</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDataObjectDefinition <em>Get Data Object Definition</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDataSetValue <em>Get Data Set Value</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDirectory <em>Get Directory</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getParentIED <em>Parent IED</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getLogSettings <em>Log Settings</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getReadWrite <em>Read Write</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getRedProt <em>Red Prot</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getReportSettings <em>Report Settings</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSMVsc <em>SM Vsc</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSupSubscription <em>Sup Subscription</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getValueHandling <em>Value Handling</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSetDataSetValue <em>Set Data Set Value</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSettingGroups <em>Setting Groups</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getTimeSyncProt <em>Time Sync Prot</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getTimerActivatedControl <em>Timer Activated Control</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSMVSettings <em>SMV Settings</em>}</li>
 * </ul>
 *
 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices()
 * @model
 * @generated
 */
public interface Services extends SclObject {
    /**
     * Returns the value of the '<em><b>Name Length</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Name Length</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Name Length</em>' attribute.
     * @see #isSetNameLength()
     * @see #unsetNameLength()
     * @see #setNameLength(Integer)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_NameLength()
     * @model unsettable="true"
     * @generated
     */
    Integer getNameLength();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getNameLength <em>Name Length</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Name Length</em>' attribute.
     * @see #isSetNameLength()
     * @see #unsetNameLength()
     * @see #getNameLength()
     * @generated
     */
    void setNameLength( Integer value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getNameLength <em>Name Length</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetNameLength()
     * @see #getNameLength()
     * @see #setNameLength(Integer)
     * @generated
     */
    void unsetNameLength();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getNameLength <em>Name Length</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Name Length</em>' attribute is set.
     * @see #unsetNameLength()
     * @see #getNameLength()
     * @see #setNameLength(Integer)
     * @generated
     */
    boolean isSetNameLength();

    /**
     * Returns the value of the '<em><b>Parent Access Point</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getServices <em>Services</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Parent Access Point</em>' container reference.
     * @see #setParentAccessPoint(AccessPoint)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_ParentAccessPoint()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getServices
     * @model opposite="Services" resolveProxies="false" unsettable="true" ordered="false"
     * @generated
     */
    AccessPoint getParentAccessPoint();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getParentAccessPoint <em>Parent Access Point</em>}' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Parent Access Point</em>' container reference.
     * @see #getParentAccessPoint()
     * @generated
     */
    void setParentAccessPoint( AccessPoint value );

    /**
     * Returns the value of the '<em><b>Client Services</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Client Services</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Client Services</em>' containment reference.
     * @see #isSetClientServices()
     * @see #unsetClientServices()
     * @see #setClientServices(ClientServices)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_ClientServices()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    ClientServices getClientServices();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getClientServices <em>Client Services</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Client Services</em>' containment reference.
     * @see #isSetClientServices()
     * @see #unsetClientServices()
     * @see #getClientServices()
     * @generated
     */
    void setClientServices( ClientServices value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getClientServices <em>Client Services</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetClientServices()
     * @see #getClientServices()
     * @see #setClientServices(ClientServices)
     * @generated
     */
    void unsetClientServices();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getClientServices <em>Client Services</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Client Services</em>' containment reference is set.
     * @see #unsetClientServices()
     * @see #getClientServices()
     * @see #setClientServices(ClientServices)
     * @generated
     */
    boolean isSetClientServices();

    /**
     * Returns the value of the '<em><b>Comm Prot</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.CommProt#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Comm Prot</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Comm Prot</em>' containment reference.
     * @see #isSetCommProt()
     * @see #unsetCommProt()
     * @see #setCommProt(CommProt)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_CommProt()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.CommProt#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    CommProt getCommProt();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getCommProt <em>Comm Prot</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Comm Prot</em>' containment reference.
     * @see #isSetCommProt()
     * @see #unsetCommProt()
     * @see #getCommProt()
     * @generated
     */
    void setCommProt( CommProt value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getCommProt <em>Comm Prot</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetCommProt()
     * @see #getCommProt()
     * @see #setCommProt(CommProt)
     * @generated
     */
    void unsetCommProt();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getCommProt <em>Comm Prot</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Comm Prot</em>' containment reference is set.
     * @see #unsetCommProt()
     * @see #getCommProt()
     * @see #setCommProt(CommProt)
     * @generated
     */
    boolean isSetCommProt();

    /**
     * Returns the value of the '<em><b>Conf Data Set</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfDataSet#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Conf Data Set</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Conf Data Set</em>' containment reference.
     * @see #isSetConfDataSet()
     * @see #unsetConfDataSet()
     * @see #setConfDataSet(ConfDataSet)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_ConfDataSet()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfDataSet#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    ConfDataSet getConfDataSet();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfDataSet <em>Conf Data Set</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Conf Data Set</em>' containment reference.
     * @see #isSetConfDataSet()
     * @see #unsetConfDataSet()
     * @see #getConfDataSet()
     * @generated
     */
    void setConfDataSet( ConfDataSet value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfDataSet <em>Conf Data Set</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetConfDataSet()
     * @see #getConfDataSet()
     * @see #setConfDataSet(ConfDataSet)
     * @generated
     */
    void unsetConfDataSet();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfDataSet <em>Conf Data Set</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Conf Data Set</em>' containment reference is set.
     * @see #unsetConfDataSet()
     * @see #getConfDataSet()
     * @see #setConfDataSet(ConfDataSet)
     * @generated
     */
    boolean isSetConfDataSet();

    /**
     * Returns the value of the '<em><b>Conf LNs</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLNs#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Conf LNs</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Conf LNs</em>' containment reference.
     * @see #isSetConfLNs()
     * @see #unsetConfLNs()
     * @see #setConfLNs(ConfLNs)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_ConfLNs()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLNs#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    ConfLNs getConfLNs();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLNs <em>Conf LNs</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Conf LNs</em>' containment reference.
     * @see #isSetConfLNs()
     * @see #unsetConfLNs()
     * @see #getConfLNs()
     * @generated
     */
    void setConfLNs( ConfLNs value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLNs <em>Conf LNs</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetConfLNs()
     * @see #getConfLNs()
     * @see #setConfLNs(ConfLNs)
     * @generated
     */
    void unsetConfLNs();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLNs <em>Conf LNs</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Conf LNs</em>' containment reference is set.
     * @see #unsetConfLNs()
     * @see #getConfLNs()
     * @see #setConfLNs(ConfLNs)
     * @generated
     */
    boolean isSetConfLNs();

    /**
     * Returns the value of the '<em><b>Conf Ld Name</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLdName#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Conf Ld Name</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Conf Ld Name</em>' containment reference.
     * @see #isSetConfLdName()
     * @see #unsetConfLdName()
     * @see #setConfLdName(ConfLdName)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_ConfLdName()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLdName#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    ConfLdName getConfLdName();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLdName <em>Conf Ld Name</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Conf Ld Name</em>' containment reference.
     * @see #isSetConfLdName()
     * @see #unsetConfLdName()
     * @see #getConfLdName()
     * @generated
     */
    void setConfLdName( ConfLdName value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLdName <em>Conf Ld Name</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetConfLdName()
     * @see #getConfLdName()
     * @see #setConfLdName(ConfLdName)
     * @generated
     */
    void unsetConfLdName();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLdName <em>Conf Ld Name</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Conf Ld Name</em>' containment reference is set.
     * @see #unsetConfLdName()
     * @see #getConfLdName()
     * @see #setConfLdName(ConfLdName)
     * @generated
     */
    boolean isSetConfLdName();

    /**
     * Returns the value of the '<em><b>Conf Log Control</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLogControl#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Conf Log Control</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Conf Log Control</em>' containment reference.
     * @see #isSetConfLogControl()
     * @see #unsetConfLogControl()
     * @see #setConfLogControl(ConfLogControl)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_ConfLogControl()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLogControl#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    ConfLogControl getConfLogControl();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLogControl <em>Conf Log Control</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Conf Log Control</em>' containment reference.
     * @see #isSetConfLogControl()
     * @see #unsetConfLogControl()
     * @see #getConfLogControl()
     * @generated
     */
    void setConfLogControl( ConfLogControl value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLogControl <em>Conf Log Control</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetConfLogControl()
     * @see #getConfLogControl()
     * @see #setConfLogControl(ConfLogControl)
     * @generated
     */
    void unsetConfLogControl();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLogControl <em>Conf Log Control</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Conf Log Control</em>' containment reference is set.
     * @see #unsetConfLogControl()
     * @see #getConfLogControl()
     * @see #setConfLogControl(ConfLogControl)
     * @generated
     */
    boolean isSetConfLogControl();

    /**
     * Returns the value of the '<em><b>Conf Report Control</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfReportControl#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Conf Report Control</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Conf Report Control</em>' containment reference.
     * @see #isSetConfReportControl()
     * @see #unsetConfReportControl()
     * @see #setConfReportControl(ConfReportControl)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_ConfReportControl()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfReportControl#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    ConfReportControl getConfReportControl();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfReportControl <em>Conf Report Control</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Conf Report Control</em>' containment reference.
     * @see #isSetConfReportControl()
     * @see #unsetConfReportControl()
     * @see #getConfReportControl()
     * @generated
     */
    void setConfReportControl( ConfReportControl value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfReportControl <em>Conf Report Control</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetConfReportControl()
     * @see #getConfReportControl()
     * @see #setConfReportControl(ConfReportControl)
     * @generated
     */
    void unsetConfReportControl();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfReportControl <em>Conf Report Control</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Conf Report Control</em>' containment reference is set.
     * @see #unsetConfReportControl()
     * @see #getConfReportControl()
     * @see #setConfReportControl(ConfReportControl)
     * @generated
     */
    boolean isSetConfReportControl();

    /**
     * Returns the value of the '<em><b>Conf Sig Ref</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfSigRef#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Conf Sig Ref</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Conf Sig Ref</em>' containment reference.
     * @see #isSetConfSigRef()
     * @see #unsetConfSigRef()
     * @see #setConfSigRef(ConfSigRef)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_ConfSigRef()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfSigRef#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    ConfSigRef getConfSigRef();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfSigRef <em>Conf Sig Ref</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Conf Sig Ref</em>' containment reference.
     * @see #isSetConfSigRef()
     * @see #unsetConfSigRef()
     * @see #getConfSigRef()
     * @generated
     */
    void setConfSigRef( ConfSigRef value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfSigRef <em>Conf Sig Ref</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetConfSigRef()
     * @see #getConfSigRef()
     * @see #setConfSigRef(ConfSigRef)
     * @generated
     */
    void unsetConfSigRef();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfSigRef <em>Conf Sig Ref</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Conf Sig Ref</em>' containment reference is set.
     * @see #unsetConfSigRef()
     * @see #getConfSigRef()
     * @see #setConfSigRef(ConfSigRef)
     * @generated
     */
    boolean isSetConfSigRef();

    /**
     * Returns the value of the '<em><b>Data Object Directory</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObjectDirectory#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Data Object Directory</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Data Object Directory</em>' containment reference.
     * @see #isSetDataObjectDirectory()
     * @see #unsetDataObjectDirectory()
     * @see #setDataObjectDirectory(DataObjectDirectory)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_DataObjectDirectory()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObjectDirectory#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    DataObjectDirectory getDataObjectDirectory();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDataObjectDirectory <em>Data Object Directory</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Data Object Directory</em>' containment reference.
     * @see #isSetDataObjectDirectory()
     * @see #unsetDataObjectDirectory()
     * @see #getDataObjectDirectory()
     * @generated
     */
    void setDataObjectDirectory( DataObjectDirectory value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDataObjectDirectory <em>Data Object Directory</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetDataObjectDirectory()
     * @see #getDataObjectDirectory()
     * @see #setDataObjectDirectory(DataObjectDirectory)
     * @generated
     */
    void unsetDataObjectDirectory();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDataObjectDirectory <em>Data Object Directory</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Data Object Directory</em>' containment reference is set.
     * @see #unsetDataObjectDirectory()
     * @see #getDataObjectDirectory()
     * @see #setDataObjectDirectory(DataObjectDirectory)
     * @generated
     */
    boolean isSetDataObjectDirectory();

    /**
     * Returns the value of the '<em><b>Data Set Directory</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSetDirectory#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Data Set Directory</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Data Set Directory</em>' containment reference.
     * @see #isSetDataSetDirectory()
     * @see #unsetDataSetDirectory()
     * @see #setDataSetDirectory(DataSetDirectory)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_DataSetDirectory()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSetDirectory#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    DataSetDirectory getDataSetDirectory();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDataSetDirectory <em>Data Set Directory</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Data Set Directory</em>' containment reference.
     * @see #isSetDataSetDirectory()
     * @see #unsetDataSetDirectory()
     * @see #getDataSetDirectory()
     * @generated
     */
    void setDataSetDirectory( DataSetDirectory value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDataSetDirectory <em>Data Set Directory</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetDataSetDirectory()
     * @see #getDataSetDirectory()
     * @see #setDataSetDirectory(DataSetDirectory)
     * @generated
     */
    void unsetDataSetDirectory();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDataSetDirectory <em>Data Set Directory</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Data Set Directory</em>' containment reference is set.
     * @see #unsetDataSetDirectory()
     * @see #getDataSetDirectory()
     * @see #setDataSetDirectory(DataSetDirectory)
     * @generated
     */
    boolean isSetDataSetDirectory();

    /**
     * Returns the value of the '<em><b>Dyn Association</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DynAssociation#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Dyn Association</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Dyn Association</em>' containment reference.
     * @see #isSetDynAssociation()
     * @see #unsetDynAssociation()
     * @see #setDynAssociation(DynAssociation)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_DynAssociation()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DynAssociation#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    DynAssociation getDynAssociation();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDynAssociation <em>Dyn Association</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Dyn Association</em>' containment reference.
     * @see #isSetDynAssociation()
     * @see #unsetDynAssociation()
     * @see #getDynAssociation()
     * @generated
     */
    void setDynAssociation( DynAssociation value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDynAssociation <em>Dyn Association</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetDynAssociation()
     * @see #getDynAssociation()
     * @see #setDynAssociation(DynAssociation)
     * @generated
     */
    void unsetDynAssociation();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDynAssociation <em>Dyn Association</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Dyn Association</em>' containment reference is set.
     * @see #unsetDynAssociation()
     * @see #getDynAssociation()
     * @see #setDynAssociation(DynAssociation)
     * @generated
     */
    boolean isSetDynAssociation();

    /**
     * Returns the value of the '<em><b>Dyn Data Set</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DynDataSet#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Dyn Data Set</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Dyn Data Set</em>' containment reference.
     * @see #isSetDynDataSet()
     * @see #unsetDynDataSet()
     * @see #setDynDataSet(DynDataSet)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_DynDataSet()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DynDataSet#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    DynDataSet getDynDataSet();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDynDataSet <em>Dyn Data Set</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Dyn Data Set</em>' containment reference.
     * @see #isSetDynDataSet()
     * @see #unsetDynDataSet()
     * @see #getDynDataSet()
     * @generated
     */
    void setDynDataSet( DynDataSet value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDynDataSet <em>Dyn Data Set</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetDynDataSet()
     * @see #getDynDataSet()
     * @see #setDynDataSet(DynDataSet)
     * @generated
     */
    void unsetDynDataSet();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDynDataSet <em>Dyn Data Set</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Dyn Data Set</em>' containment reference is set.
     * @see #unsetDynDataSet()
     * @see #getDynDataSet()
     * @see #setDynDataSet(DynDataSet)
     * @generated
     */
    boolean isSetDynDataSet();

    /**
     * Returns the value of the '<em><b>File Handling</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>File Handling</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>File Handling</em>' containment reference.
     * @see #isSetFileHandling()
     * @see #unsetFileHandling()
     * @see #setFileHandling(FileHandling)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_FileHandling()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    FileHandling getFileHandling();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getFileHandling <em>File Handling</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>File Handling</em>' containment reference.
     * @see #isSetFileHandling()
     * @see #unsetFileHandling()
     * @see #getFileHandling()
     * @generated
     */
    void setFileHandling( FileHandling value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getFileHandling <em>File Handling</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetFileHandling()
     * @see #getFileHandling()
     * @see #setFileHandling(FileHandling)
     * @generated
     */
    void unsetFileHandling();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getFileHandling <em>File Handling</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>File Handling</em>' containment reference is set.
     * @see #unsetFileHandling()
     * @see #getFileHandling()
     * @see #setFileHandling(FileHandling)
     * @generated
     */
    boolean isSetFileHandling();

    /**
     * Returns the value of the '<em><b>GOOSE</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSE#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>GOOSE</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>GOOSE</em>' containment reference.
     * @see #isSetGOOSE()
     * @see #unsetGOOSE()
     * @see #setGOOSE(GOOSE)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_GOOSE()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSE#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    GOOSE getGOOSE();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGOOSE <em>GOOSE</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>GOOSE</em>' containment reference.
     * @see #isSetGOOSE()
     * @see #unsetGOOSE()
     * @see #getGOOSE()
     * @generated
     */
    void setGOOSE( GOOSE value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGOOSE <em>GOOSE</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetGOOSE()
     * @see #getGOOSE()
     * @see #setGOOSE(GOOSE)
     * @generated
     */
    void unsetGOOSE();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGOOSE <em>GOOSE</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>GOOSE</em>' containment reference is set.
     * @see #unsetGOOSE()
     * @see #getGOOSE()
     * @see #setGOOSE(GOOSE)
     * @generated
     */
    boolean isSetGOOSE();

    /**
     * Returns the value of the '<em><b>GSE Dir</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEDir#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>GSE Dir</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>GSE Dir</em>' containment reference.
     * @see #isSetGSEDir()
     * @see #unsetGSEDir()
     * @see #setGSEDir(GSEDir)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_GSEDir()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEDir#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    GSEDir getGSEDir();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSEDir <em>GSE Dir</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>GSE Dir</em>' containment reference.
     * @see #isSetGSEDir()
     * @see #unsetGSEDir()
     * @see #getGSEDir()
     * @generated
     */
    void setGSEDir( GSEDir value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSEDir <em>GSE Dir</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetGSEDir()
     * @see #getGSEDir()
     * @see #setGSEDir(GSEDir)
     * @generated
     */
    void unsetGSEDir();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSEDir <em>GSE Dir</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>GSE Dir</em>' containment reference is set.
     * @see #unsetGSEDir()
     * @see #getGSEDir()
     * @see #setGSEDir(GSEDir)
     * @generated
     */
    boolean isSetGSEDir();

    /**
     * Returns the value of the '<em><b>GSE Settings</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSESettings#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>GSE Settings</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>GSE Settings</em>' containment reference.
     * @see #isSetGSESettings()
     * @see #unsetGSESettings()
     * @see #setGSESettings(GSESettings)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_GSESettings()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSESettings#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    GSESettings getGSESettings();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSESettings <em>GSE Settings</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>GSE Settings</em>' containment reference.
     * @see #isSetGSESettings()
     * @see #unsetGSESettings()
     * @see #getGSESettings()
     * @generated
     */
    void setGSESettings( GSESettings value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSESettings <em>GSE Settings</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetGSESettings()
     * @see #getGSESettings()
     * @see #setGSESettings(GSESettings)
     * @generated
     */
    void unsetGSESettings();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSESettings <em>GSE Settings</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>GSE Settings</em>' containment reference is set.
     * @see #unsetGSESettings()
     * @see #getGSESettings()
     * @see #setGSESettings(GSESettings)
     * @generated
     */
    boolean isSetGSESettings();

    /**
     * Returns the value of the '<em><b>GSSE</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSSE#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>GSSE</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>GSSE</em>' containment reference.
     * @see #isSetGSSE()
     * @see #unsetGSSE()
     * @see #setGSSE(GSSE)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_GSSE()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSSE#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    GSSE getGSSE();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSSE <em>GSSE</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>GSSE</em>' containment reference.
     * @see #isSetGSSE()
     * @see #unsetGSSE()
     * @see #getGSSE()
     * @generated
     */
    void setGSSE( GSSE value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSSE <em>GSSE</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetGSSE()
     * @see #getGSSE()
     * @see #setGSSE(GSSE)
     * @generated
     */
    void unsetGSSE();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSSE <em>GSSE</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>GSSE</em>' containment reference is set.
     * @see #unsetGSSE()
     * @see #getGSSE()
     * @see #setGSSE(GSSE)
     * @generated
     */
    boolean isSetGSSE();

    /**
     * Returns the value of the '<em><b>Get CB Values</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GetCBValues#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Get CB Values</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Get CB Values</em>' containment reference.
     * @see #isSetGetCBValues()
     * @see #unsetGetCBValues()
     * @see #setGetCBValues(GetCBValues)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_GetCBValues()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GetCBValues#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    GetCBValues getGetCBValues();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetCBValues <em>Get CB Values</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Get CB Values</em>' containment reference.
     * @see #isSetGetCBValues()
     * @see #unsetGetCBValues()
     * @see #getGetCBValues()
     * @generated
     */
    void setGetCBValues( GetCBValues value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetCBValues <em>Get CB Values</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetGetCBValues()
     * @see #getGetCBValues()
     * @see #setGetCBValues(GetCBValues)
     * @generated
     */
    void unsetGetCBValues();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetCBValues <em>Get CB Values</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Get CB Values</em>' containment reference is set.
     * @see #unsetGetCBValues()
     * @see #getGetCBValues()
     * @see #setGetCBValues(GetCBValues)
     * @generated
     */
    boolean isSetGetCBValues();

    /**
     * Returns the value of the '<em><b>Get Data Object Definition</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDataObjectDefinition#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Get Data Object Definition</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Get Data Object Definition</em>' containment reference.
     * @see #isSetGetDataObjectDefinition()
     * @see #unsetGetDataObjectDefinition()
     * @see #setGetDataObjectDefinition(GetDataObjectDefinition)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_GetDataObjectDefinition()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDataObjectDefinition#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    GetDataObjectDefinition getGetDataObjectDefinition();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDataObjectDefinition <em>Get Data Object Definition</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Get Data Object Definition</em>' containment reference.
     * @see #isSetGetDataObjectDefinition()
     * @see #unsetGetDataObjectDefinition()
     * @see #getGetDataObjectDefinition()
     * @generated
     */
    void setGetDataObjectDefinition( GetDataObjectDefinition value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDataObjectDefinition <em>Get Data Object Definition</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetGetDataObjectDefinition()
     * @see #getGetDataObjectDefinition()
     * @see #setGetDataObjectDefinition(GetDataObjectDefinition)
     * @generated
     */
    void unsetGetDataObjectDefinition();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDataObjectDefinition <em>Get Data Object Definition</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Get Data Object Definition</em>' containment reference is set.
     * @see #unsetGetDataObjectDefinition()
     * @see #getGetDataObjectDefinition()
     * @see #setGetDataObjectDefinition(GetDataObjectDefinition)
     * @generated
     */
    boolean isSetGetDataObjectDefinition();

    /**
     * Returns the value of the '<em><b>Get Data Set Value</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDataSetValue#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Get Data Set Value</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Get Data Set Value</em>' containment reference.
     * @see #isSetGetDataSetValue()
     * @see #unsetGetDataSetValue()
     * @see #setGetDataSetValue(GetDataSetValue)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_GetDataSetValue()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDataSetValue#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    GetDataSetValue getGetDataSetValue();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDataSetValue <em>Get Data Set Value</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Get Data Set Value</em>' containment reference.
     * @see #isSetGetDataSetValue()
     * @see #unsetGetDataSetValue()
     * @see #getGetDataSetValue()
     * @generated
     */
    void setGetDataSetValue( GetDataSetValue value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDataSetValue <em>Get Data Set Value</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetGetDataSetValue()
     * @see #getGetDataSetValue()
     * @see #setGetDataSetValue(GetDataSetValue)
     * @generated
     */
    void unsetGetDataSetValue();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDataSetValue <em>Get Data Set Value</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Get Data Set Value</em>' containment reference is set.
     * @see #unsetGetDataSetValue()
     * @see #getGetDataSetValue()
     * @see #setGetDataSetValue(GetDataSetValue)
     * @generated
     */
    boolean isSetGetDataSetValue();

    /**
     * Returns the value of the '<em><b>Get Directory</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDirectory#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Get Directory</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Get Directory</em>' containment reference.
     * @see #isSetGetDirectory()
     * @see #unsetGetDirectory()
     * @see #setGetDirectory(GetDirectory)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_GetDirectory()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDirectory#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    GetDirectory getGetDirectory();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDirectory <em>Get Directory</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Get Directory</em>' containment reference.
     * @see #isSetGetDirectory()
     * @see #unsetGetDirectory()
     * @see #getGetDirectory()
     * @generated
     */
    void setGetDirectory( GetDirectory value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDirectory <em>Get Directory</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetGetDirectory()
     * @see #getGetDirectory()
     * @see #setGetDirectory(GetDirectory)
     * @generated
     */
    void unsetGetDirectory();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDirectory <em>Get Directory</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Get Directory</em>' containment reference is set.
     * @see #unsetGetDirectory()
     * @see #getGetDirectory()
     * @see #setGetDirectory(GetDirectory)
     * @generated
     */
    boolean isSetGetDirectory();

    /**
     * Returns the value of the '<em><b>Parent IED</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getServices <em>Services</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Parent IED</em>' container reference.
     * @see #setParentIED(IED)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_ParentIED()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getServices
     * @model opposite="Services" resolveProxies="false" unsettable="true" ordered="false"
     * @generated
     */
    IED getParentIED();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getParentIED <em>Parent IED</em>}' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Parent IED</em>' container reference.
     * @see #getParentIED()
     * @generated
     */
    void setParentIED( IED value );

    /**
     * Returns the value of the '<em><b>Log Settings</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Log Settings</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Log Settings</em>' containment reference.
     * @see #isSetLogSettings()
     * @see #unsetLogSettings()
     * @see #setLogSettings(LogSettings)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_LogSettings()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    LogSettings getLogSettings();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getLogSettings <em>Log Settings</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Log Settings</em>' containment reference.
     * @see #isSetLogSettings()
     * @see #unsetLogSettings()
     * @see #getLogSettings()
     * @generated
     */
    void setLogSettings( LogSettings value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getLogSettings <em>Log Settings</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetLogSettings()
     * @see #getLogSettings()
     * @see #setLogSettings(LogSettings)
     * @generated
     */
    void unsetLogSettings();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getLogSettings <em>Log Settings</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Log Settings</em>' containment reference is set.
     * @see #unsetLogSettings()
     * @see #getLogSettings()
     * @see #setLogSettings(LogSettings)
     * @generated
     */
    boolean isSetLogSettings();

    /**
     * Returns the value of the '<em><b>Read Write</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReadWrite#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Read Write</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Read Write</em>' containment reference.
     * @see #isSetReadWrite()
     * @see #unsetReadWrite()
     * @see #setReadWrite(ReadWrite)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_ReadWrite()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReadWrite#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    ReadWrite getReadWrite();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getReadWrite <em>Read Write</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Read Write</em>' containment reference.
     * @see #isSetReadWrite()
     * @see #unsetReadWrite()
     * @see #getReadWrite()
     * @generated
     */
    void setReadWrite( ReadWrite value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getReadWrite <em>Read Write</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetReadWrite()
     * @see #getReadWrite()
     * @see #setReadWrite(ReadWrite)
     * @generated
     */
    void unsetReadWrite();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getReadWrite <em>Read Write</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Read Write</em>' containment reference is set.
     * @see #unsetReadWrite()
     * @see #getReadWrite()
     * @see #setReadWrite(ReadWrite)
     * @generated
     */
    boolean isSetReadWrite();

    /**
     * Returns the value of the '<em><b>Red Prot</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Red Prot</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Red Prot</em>' containment reference.
     * @see #isSetRedProt()
     * @see #unsetRedProt()
     * @see #setRedProt(RedProt)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_RedProt()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    RedProt getRedProt();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getRedProt <em>Red Prot</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Red Prot</em>' containment reference.
     * @see #isSetRedProt()
     * @see #unsetRedProt()
     * @see #getRedProt()
     * @generated
     */
    void setRedProt( RedProt value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getRedProt <em>Red Prot</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetRedProt()
     * @see #getRedProt()
     * @see #setRedProt(RedProt)
     * @generated
     */
    void unsetRedProt();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getRedProt <em>Red Prot</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Red Prot</em>' containment reference is set.
     * @see #unsetRedProt()
     * @see #getRedProt()
     * @see #setRedProt(RedProt)
     * @generated
     */
    boolean isSetRedProt();

    /**
     * Returns the value of the '<em><b>Report Settings</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Report Settings</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Report Settings</em>' containment reference.
     * @see #isSetReportSettings()
     * @see #unsetReportSettings()
     * @see #setReportSettings(ReportSettings)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_ReportSettings()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    ReportSettings getReportSettings();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getReportSettings <em>Report Settings</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Report Settings</em>' containment reference.
     * @see #isSetReportSettings()
     * @see #unsetReportSettings()
     * @see #getReportSettings()
     * @generated
     */
    void setReportSettings( ReportSettings value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getReportSettings <em>Report Settings</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetReportSettings()
     * @see #getReportSettings()
     * @see #setReportSettings(ReportSettings)
     * @generated
     */
    void unsetReportSettings();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getReportSettings <em>Report Settings</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Report Settings</em>' containment reference is set.
     * @see #unsetReportSettings()
     * @see #getReportSettings()
     * @see #setReportSettings(ReportSettings)
     * @generated
     */
    boolean isSetReportSettings();

    /**
     * Returns the value of the '<em><b>SM Vsc</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVsc#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SM Vsc</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>SM Vsc</em>' containment reference.
     * @see #isSetSMVsc()
     * @see #unsetSMVsc()
     * @see #setSMVsc(SMVsc)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_SMVsc()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVsc#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    SMVsc getSMVsc();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSMVsc <em>SM Vsc</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>SM Vsc</em>' containment reference.
     * @see #isSetSMVsc()
     * @see #unsetSMVsc()
     * @see #getSMVsc()
     * @generated
     */
    void setSMVsc( SMVsc value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSMVsc <em>SM Vsc</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetSMVsc()
     * @see #getSMVsc()
     * @see #setSMVsc(SMVsc)
     * @generated
     */
    void unsetSMVsc();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSMVsc <em>SM Vsc</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>SM Vsc</em>' containment reference is set.
     * @see #unsetSMVsc()
     * @see #getSMVsc()
     * @see #setSMVsc(SMVsc)
     * @generated
     */
    boolean isSetSMVsc();

    /**
     * Returns the value of the '<em><b>Sup Subscription</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Sup Subscription</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Sup Subscription</em>' containment reference.
     * @see #isSetSupSubscription()
     * @see #unsetSupSubscription()
     * @see #setSupSubscription(SupSubscription)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_SupSubscription()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    SupSubscription getSupSubscription();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSupSubscription <em>Sup Subscription</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Sup Subscription</em>' containment reference.
     * @see #isSetSupSubscription()
     * @see #unsetSupSubscription()
     * @see #getSupSubscription()
     * @generated
     */
    void setSupSubscription( SupSubscription value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSupSubscription <em>Sup Subscription</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetSupSubscription()
     * @see #getSupSubscription()
     * @see #setSupSubscription(SupSubscription)
     * @generated
     */
    void unsetSupSubscription();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSupSubscription <em>Sup Subscription</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Sup Subscription</em>' containment reference is set.
     * @see #unsetSupSubscription()
     * @see #getSupSubscription()
     * @see #setSupSubscription(SupSubscription)
     * @generated
     */
    boolean isSetSupSubscription();

    /**
     * Returns the value of the '<em><b>Value Handling</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueHandling#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Value Handling</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Value Handling</em>' containment reference.
     * @see #isSetValueHandling()
     * @see #unsetValueHandling()
     * @see #setValueHandling(ValueHandling)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_ValueHandling()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueHandling#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    ValueHandling getValueHandling();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getValueHandling <em>Value Handling</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Value Handling</em>' containment reference.
     * @see #isSetValueHandling()
     * @see #unsetValueHandling()
     * @see #getValueHandling()
     * @generated
     */
    void setValueHandling( ValueHandling value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getValueHandling <em>Value Handling</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetValueHandling()
     * @see #getValueHandling()
     * @see #setValueHandling(ValueHandling)
     * @generated
     */
    void unsetValueHandling();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getValueHandling <em>Value Handling</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Value Handling</em>' containment reference is set.
     * @see #unsetValueHandling()
     * @see #getValueHandling()
     * @see #setValueHandling(ValueHandling)
     * @generated
     */
    boolean isSetValueHandling();

    /**
     * Returns the value of the '<em><b>Set Data Set Value</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SetDataSetValue#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Set Data Set Value</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Set Data Set Value</em>' containment reference.
     * @see #isSetSetDataSetValue()
     * @see #unsetSetDataSetValue()
     * @see #setSetDataSetValue(SetDataSetValue)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_SetDataSetValue()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SetDataSetValue#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    SetDataSetValue getSetDataSetValue();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSetDataSetValue <em>Set Data Set Value</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Set Data Set Value</em>' containment reference.
     * @see #isSetSetDataSetValue()
     * @see #unsetSetDataSetValue()
     * @see #getSetDataSetValue()
     * @generated
     */
    void setSetDataSetValue( SetDataSetValue value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSetDataSetValue <em>Set Data Set Value</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetSetDataSetValue()
     * @see #getSetDataSetValue()
     * @see #setSetDataSetValue(SetDataSetValue)
     * @generated
     */
    void unsetSetDataSetValue();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSetDataSetValue <em>Set Data Set Value</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Set Data Set Value</em>' containment reference is set.
     * @see #unsetSetDataSetValue()
     * @see #getSetDataSetValue()
     * @see #setSetDataSetValue(SetDataSetValue)
     * @generated
     */
    boolean isSetSetDataSetValue();

    /**
     * Returns the value of the '<em><b>Setting Groups</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingGroups#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Setting Groups</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Setting Groups</em>' containment reference.
     * @see #isSetSettingGroups()
     * @see #unsetSettingGroups()
     * @see #setSettingGroups(SettingGroups)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_SettingGroups()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingGroups#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    SettingGroups getSettingGroups();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSettingGroups <em>Setting Groups</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Setting Groups</em>' containment reference.
     * @see #isSetSettingGroups()
     * @see #unsetSettingGroups()
     * @see #getSettingGroups()
     * @generated
     */
    void setSettingGroups( SettingGroups value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSettingGroups <em>Setting Groups</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetSettingGroups()
     * @see #getSettingGroups()
     * @see #setSettingGroups(SettingGroups)
     * @generated
     */
    void unsetSettingGroups();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSettingGroups <em>Setting Groups</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Setting Groups</em>' containment reference is set.
     * @see #unsetSettingGroups()
     * @see #getSettingGroups()
     * @see #setSettingGroups(SettingGroups)
     * @generated
     */
    boolean isSetSettingGroups();

    /**
     * Returns the value of the '<em><b>Time Sync Prot</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Time Sync Prot</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Time Sync Prot</em>' containment reference.
     * @see #isSetTimeSyncProt()
     * @see #unsetTimeSyncProt()
     * @see #setTimeSyncProt(TimeSyncProt)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_TimeSyncProt()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    TimeSyncProt getTimeSyncProt();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getTimeSyncProt <em>Time Sync Prot</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Time Sync Prot</em>' containment reference.
     * @see #isSetTimeSyncProt()
     * @see #unsetTimeSyncProt()
     * @see #getTimeSyncProt()
     * @generated
     */
    void setTimeSyncProt( TimeSyncProt value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getTimeSyncProt <em>Time Sync Prot</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetTimeSyncProt()
     * @see #getTimeSyncProt()
     * @see #setTimeSyncProt(TimeSyncProt)
     * @generated
     */
    void unsetTimeSyncProt();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getTimeSyncProt <em>Time Sync Prot</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Time Sync Prot</em>' containment reference is set.
     * @see #unsetTimeSyncProt()
     * @see #getTimeSyncProt()
     * @see #setTimeSyncProt(TimeSyncProt)
     * @generated
     */
    boolean isSetTimeSyncProt();

    /**
     * Returns the value of the '<em><b>Timer Activated Control</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TimerActivatedControl#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Timer Activated Control</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Timer Activated Control</em>' containment reference.
     * @see #isSetTimerActivatedControl()
     * @see #unsetTimerActivatedControl()
     * @see #setTimerActivatedControl(TimerActivatedControl)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_TimerActivatedControl()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TimerActivatedControl#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    TimerActivatedControl getTimerActivatedControl();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getTimerActivatedControl <em>Timer Activated Control</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Timer Activated Control</em>' containment reference.
     * @see #isSetTimerActivatedControl()
     * @see #unsetTimerActivatedControl()
     * @see #getTimerActivatedControl()
     * @generated
     */
    void setTimerActivatedControl( TimerActivatedControl value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getTimerActivatedControl <em>Timer Activated Control</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetTimerActivatedControl()
     * @see #getTimerActivatedControl()
     * @see #setTimerActivatedControl(TimerActivatedControl)
     * @generated
     */
    void unsetTimerActivatedControl();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getTimerActivatedControl <em>Timer Activated Control</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Timer Activated Control</em>' containment reference is set.
     * @see #unsetTimerActivatedControl()
     * @see #getTimerActivatedControl()
     * @see #setTimerActivatedControl(TimerActivatedControl)
     * @generated
     */
    boolean isSetTimerActivatedControl();

    /**
     * Returns the value of the '<em><b>SMV Settings</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getParentServices <em>Parent Services</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SMV Settings</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>SMV Settings</em>' containment reference.
     * @see #isSetSMVSettings()
     * @see #unsetSMVSettings()
     * @see #setSMVSettings(SMVSettings)
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage#getServices_SMVSettings()
     * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getParentServices
     * @model opposite="ParentServices" containment="true" unsettable="true" ordered="false"
     * @generated
     */
    SMVSettings getSMVSettings();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSMVSettings <em>SMV Settings</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>SMV Settings</em>' containment reference.
     * @see #isSetSMVSettings()
     * @see #unsetSMVSettings()
     * @see #getSMVSettings()
     * @generated
     */
    void setSMVSettings( SMVSettings value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSMVSettings <em>SMV Settings</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetSMVSettings()
     * @see #getSMVSettings()
     * @see #setSMVSettings(SMVSettings)
     * @generated
     */
    void unsetSMVSettings();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSMVSettings <em>SMV Settings</em>}' containment reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>SMV Settings</em>' containment reference is set.
     * @see #unsetSMVSettings()
     * @see #getSMVSettings()
     * @see #setSMVSettings(SMVSettings)
     * @generated
     */
    boolean isSetSMVSettings();

} // Services
